using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_kinfoQuestions
    /// </summary>
    public partial class T_Sys_kinfoQuestions
    {
        public T_Sys_kinfoQuestions()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Sys_kinfoQuestions");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_kinfoQuestions");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_kinfoQuestions model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_kinfoQuestions(");
            strSql.Append("KINFO_ID,KINFO_KNAME,KINFO_KCONTENT,ReKINFO_KNAME,ReKINFO_KCONTENT,KINFO_BEGINDATE,KINFO_DISABLEDATE,ReUser,KINFO_REASON,ReKINFO_REASON,F_State,F_IsDelete,F_CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@KINFO_ID,@KINFO_KNAME,@KINFO_KCONTENT,@ReKINFO_KNAME,@ReKINFO_KCONTENT,@KINFO_BEGINDATE,@KINFO_DISABLEDATE,@ReUser,@KINFO_REASON,@ReKINFO_REASON,@F_State,@F_IsDelete,@F_CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@KINFO_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@KINFO_KNAME", SqlDbType.NVarChar,200),
                    new SqlParameter("@KINFO_KCONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ReKINFO_KNAME", SqlDbType.NVarChar,200),
                    new SqlParameter("@ReKINFO_KCONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@KINFO_BEGINDATE", SqlDbType.DateTime),
                    new SqlParameter("@KINFO_DISABLEDATE", SqlDbType.DateTime),
                    new SqlParameter("@ReUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@KINFO_REASON", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ReKINFO_REASON", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.KINFO_ID;
            parameters[1].Value = model.KINFO_KNAME;
            parameters[2].Value = model.KINFO_KCONTENT;
            parameters[3].Value = model.ReKINFO_KNAME;
            parameters[4].Value = model.ReKINFO_KCONTENT;
            parameters[5].Value = model.KINFO_BEGINDATE;
            parameters[6].Value = model.KINFO_DISABLEDATE;
            parameters[7].Value = model.ReUser;
            parameters[8].Value = model.KINFO_REASON;
            parameters[9].Value = model.ReKINFO_REASON;
            parameters[10].Value = model.F_State;
            parameters[11].Value = model.F_IsDelete;
            parameters[12].Value = model.F_CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_kinfoQuestions model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_kinfoQuestions set ");
            strSql.Append("KINFO_ID=@KINFO_ID,");
            strSql.Append("KINFO_KNAME=@KINFO_KNAME,");
            strSql.Append("KINFO_KCONTENT=@KINFO_KCONTENT,");
            strSql.Append("ReKINFO_KNAME=@ReKINFO_KNAME,");
            strSql.Append("ReKINFO_KCONTENT=@ReKINFO_KCONTENT,");
            strSql.Append("KINFO_BEGINDATE=@KINFO_BEGINDATE,");
            strSql.Append("KINFO_DISABLEDATE=@KINFO_DISABLEDATE,");
            strSql.Append("ReUser=@ReUser,");
            strSql.Append("KINFO_REASON=@KINFO_REASON,");
            strSql.Append("ReKINFO_REASON=@ReKINFO_REASON,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_CreateTime=@F_CreateTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@KINFO_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@KINFO_KNAME", SqlDbType.NVarChar,200),
                    new SqlParameter("@KINFO_KCONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ReKINFO_KNAME", SqlDbType.NVarChar,200),
                    new SqlParameter("@ReKINFO_KCONTENT", SqlDbType.NVarChar,-1),
                    new SqlParameter("@KINFO_BEGINDATE", SqlDbType.DateTime),
                    new SqlParameter("@KINFO_DISABLEDATE", SqlDbType.DateTime),
                    new SqlParameter("@ReUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@KINFO_REASON", SqlDbType.NVarChar,-1),
                    new SqlParameter("@ReKINFO_REASON", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.KINFO_ID;
            parameters[1].Value = model.KINFO_KNAME;
            parameters[2].Value = model.KINFO_KCONTENT;
            parameters[3].Value = model.ReKINFO_KNAME;
            parameters[4].Value = model.ReKINFO_KCONTENT;
            parameters[5].Value = model.KINFO_BEGINDATE;
            parameters[6].Value = model.KINFO_DISABLEDATE;
            parameters[7].Value = model.ReUser;
            parameters[8].Value = model.KINFO_REASON;
            parameters[9].Value = model.ReKINFO_REASON;
            parameters[10].Value = model.F_State;
            parameters[11].Value = model.F_IsDelete;
            parameters[12].Value = model.F_CreateTime;
            parameters[13].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_kinfoQuestions ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_kinfoQuestions ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_kinfoQuestions GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,KINFO_ID,KINFO_KNAME,KINFO_KCONTENT,ReKINFO_KNAME,ReKINFO_KCONTENT,KINFO_BEGINDATE,KINFO_DISABLEDATE,ReUser,KINFO_REASON,ReKINFO_REASON,F_State,F_IsDelete,F_CreateTime from T_Sys_kinfoQuestions ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Sys_kinfoQuestions model = new CallCenterApi.Model.T_Sys_kinfoQuestions();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_kinfoQuestions DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_kinfoQuestions model = new CallCenterApi.Model.T_Sys_kinfoQuestions();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["KINFO_ID"] != null && row["KINFO_ID"].ToString() != "")
                {
                    model.KINFO_ID = row["KINFO_ID"].ToString();
                }
                if (row["KINFO_KNAME"] != null)
                {
                    model.KINFO_KNAME = row["KINFO_KNAME"].ToString();
                }
                if (row["KINFO_KCONTENT"] != null)
                {
                    model.KINFO_KCONTENT = row["KINFO_KCONTENT"].ToString();
                }
                if (row["ReKINFO_KNAME"] != null)
                {
                    model.ReKINFO_KNAME = row["ReKINFO_KNAME"].ToString();
                }
                if (row["ReKINFO_KCONTENT"] != null)
                {
                    model.ReKINFO_KCONTENT = row["ReKINFO_KCONTENT"].ToString();
                }
                if (row["KINFO_BEGINDATE"] != null && row["KINFO_BEGINDATE"].ToString() != "")
                {
                    model.KINFO_BEGINDATE = DateTime.Parse(row["KINFO_BEGINDATE"].ToString());
                }
                if (row["KINFO_DISABLEDATE"] != null && row["KINFO_DISABLEDATE"].ToString() != "")
                {
                    model.KINFO_DISABLEDATE = DateTime.Parse(row["KINFO_DISABLEDATE"].ToString());
                }
                if (row["ReUser"] != null)
                {
                    model.ReUser = row["ReUser"].ToString();
                }
                if (row["KINFO_REASON"] != null)
                {
                    model.KINFO_REASON = row["KINFO_REASON"].ToString();
                }
                if (row["ReKINFO_REASON"] != null)
                {
                    model.ReKINFO_REASON = row["ReKINFO_REASON"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,KINFO_ID,KINFO_KNAME,KINFO_KCONTENT,ReKINFO_KNAME,ReKINFO_KCONTENT,KINFO_BEGINDATE,KINFO_DISABLEDATE,ReUser,KINFO_REASON,ReKINFO_REASON,F_State,F_IsDelete,F_CreateTime ");
            strSql.Append(" FROM T_Sys_kinfoQuestions ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,KINFO_ID,KINFO_KNAME,KINFO_KCONTENT,ReKINFO_KNAME,ReKINFO_KCONTENT,KINFO_BEGINDATE,KINFO_DISABLEDATE,ReUser,KINFO_REASON,ReKINFO_REASON,F_State,F_IsDelete,F_CreateTime ");
            strSql.Append(" FROM T_Sys_kinfoQuestions ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_kinfoQuestions ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_kinfoQuestions T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_kinfoQuestions";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return CallCenterApi.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
